Index: channeleditor.cpp
===================================================================
--- channeleditor.cpp	(revision 6764)
+++ channeleditor.cpp	(working copy)
@@ -253,8 +253,6 @@
     h->addChild(buttonScan);
     h->addChild(buttonAdvanced);
     addChild(h);
-#else
-    addChild(buttonScan);
 #endif
 
     connect(source, SIGNAL(valueChanged(const QString&)),
@@ -337,14 +335,14 @@
 
 void ChannelEditor::scan()
 {
-#ifdef USING_BACKEND
+#ifdef USING_DVB
     ScanWizard scanwizard;
     scanwizard.exec(false,true);
 
     list->fillSelections();
     list->setFocus();
 #else
-    VERBOSE(VB_IMPORTANT,  "You must compile the backend "
+    VERBOSE(VB_IMPORTANT,  "You must compile the backend with dvb support"
             "to be able to scan for channels");
 #endif
 }
Index: libmythtv.pro
===================================================================
--- libmythtv.pro	(revision 6764)
+++ libmythtv.pro	(working copy)
@@ -182,14 +182,6 @@
     SOURCES += signalmonitor.cpp           dtvsignalmonitor.cpp
     SOURCES += signalmonitorvalue.cpp
 
-    # Channel scanner stuff
-    HEADERS += scanwizard.h                scanwizardhelpers.h
-    HEADERS += analogscan.h
-    HEADERS += frequencytables.h
-    SOURCES += scanwizard.cpp              scanwizardhelpers.cpp
-    SOURCES += analogscan.cpp
-    SOURCES += frequencytables.cpp
-
     # TVRec & Recorder base classes
     HEADERS += tv_rec.h
     HEADERS += recorderbase.h              dtvrecorder.h
@@ -268,6 +260,12 @@
         HEADERS += dvbrecorder.h
         SOURCES += dvbrecorder.cpp
 
+        # Channel scanner stuff
+        HEADERS += scanwizard.h                scanwizardhelpers.h
+        HEADERS += frequencytables.h
+        SOURCES += scanwizard.cpp              scanwizardhelpers.cpp
+        SOURCES += frequencytables.cpp
+
         # Misc
         HEADERS += dvbtransporteditor.h   dvbconfparser.h   dvbdev/dvbci.h
         SOURCES += dvbtransporteditor.cpp dvbconfparser.cpp dvbdev/dvbci.cpp
Index: scanwizard.cpp
===================================================================
--- scanwizard.cpp	(revision 6764)
+++ scanwizard.cpp	(working copy)
@@ -43,7 +43,6 @@
 #endif
 #include "videosource.h"
 #include "frequencies.h"
-#include "analogscan.h"
 #include "mythdbcon.h"
 
 #include "scanwizard.h"
@@ -65,7 +64,6 @@
     dvbchannel = NULL;
     monitor = NULL;
 #endif
-    analogScan = NULL;
     scanthread_running = false;
     setLabel(strTitle);
     setUseLabel(false);
@@ -98,12 +96,6 @@
         dvbchannel = NULL;
     }
 #endif
-    if (analogScan)
-    {
-        analogScan->stop();
-        delete analogScan;
-        analogScan=NULL;
-    }
 }
 
 void ScanWizardScanner::customEvent(QCustomEvent *e)
@@ -303,48 +295,8 @@
 
     nScanType = parent->scanType();
     nVideoSource = parent->videoSource();
-    if (nScanType == ScanTypeSetting::FullScan_Analog)
-    {
-        //Create an analog scan object
-        analogScan = new AnalogScan(nVideoSource, parent->captureCard());
-
-        MSqlQuery query(MSqlQuery::InitCon());
-
-        QString thequery = QString("SELECT freqtable "
-                               "FROM videosource WHERE "
-                               "sourceid = \"%1\";")
-                               .arg(nVideoSource);
-        query.prepare(thequery);
-
-        if (!query.exec() || !query.isActive())
-            MythContext::DBError("fetchtuningparams", query);
-        if (query.size() <= 0)
-             return;
-        query.next();
-
-        QString freqtable = query.value(0).toString();
-//        cerr << "frequency table = " << freqtable.ascii() << endl; 
-
-        popupProgress = new ScanProgressPopup(this,false);
-        connect(analogScan,SIGNAL(serviceScanComplete(void)),
-                this,SLOT(scanComplete(void)));
-        connect(analogScan,SIGNAL(serviceScanUpdateText(const QString&)),
-                this,SLOT(updateText(const QString&)));
-        connect(analogScan,SIGNAL(serviceScanPCTComplete(int)),
-                this,SLOT(serviceScanPctComplete(int)));
-        popupProgress->progress(0);
-        popupProgress->exec(this);
-
-        if (!analogScan->scan(freqtable))
-        {
-             MythPopupBox::showOkPopup(gContext->GetMainWindow(),
-                                      tr("ScanWizard"),
-                                      tr("Error starting scan"));
-             cancelScan();
-        }
-    }
 #ifdef USING_DVB
-    else if (nScanType == ScanTypeSetting::Import)
+    if (nScanType == ScanTypeSetting::Import)
     {
         //cerr << "cardtype = " << parent->nCardType << " filename = " << parent->filename() << endl;
         DVBConfParser *parser = NULL;
Index: scanwizardhelpers.cpp
===================================================================
--- scanwizardhelpers.cpp	(revision 6764)
+++ scanwizardhelpers.cpp	(working copy)
@@ -121,7 +121,7 @@
         "FROM cardinput, videosource, capturecard "
         "WHERE cardinput.sourceid=videosource.sourceid AND "
         "      cardinput.cardid=capturecard.cardid AND "
-        "      capturecard.cardtype in (\"DVB\",\"MPEG\",\"V4L\") AND "
+        "      capturecard.cardtype in (\"DVB\") AND "
         "      capturecard.hostname = '%1'").arg(gContext->GetHostName());
     
     query.prepare(querystr);
@@ -203,7 +203,7 @@
         "WHERE videosource.sourceid = %1 AND "
         "      cardinput.sourceid   = videosource.sourceid AND "
         "      cardinput.cardid     = capturecard.cardid AND "
-        "      capturecard.cardtype in (\"DVB\",\"MPEG\",\"V4L\") AND "
+        "      capturecard.cardtype in (\"DVB\") AND "
         "      capturecard.hostname = '%2';")
         .arg(nSourceID).arg(gContext->GetHostName());
     query.prepare(thequery);
Index: scanwizard.h
===================================================================
--- scanwizard.h	(revision 6764)
+++ scanwizard.h	(working copy)
@@ -54,7 +54,6 @@
 class OptionalTypeSetting;
 class ScanWizard;
 class ScanWizardScanner;
-class AnalogScan;
 
 class ScanWizard: public ConfigurationWizard 
 {
@@ -129,7 +128,6 @@
     static void *SpawnTune(void *param);
 
     ScanWizard        *parent;
-    AnalogScan        *analogScan;
     LogList           *log;
     bool               scanthread_running;
     bool               tunerthread_running;