Index: programs/mythfrontend/util_menu.xml
===================================================================
--- programs/mythfrontend/util_menu.xml	(Revision 6964)
+++ programs/mythfrontend/util_menu.xml	(Arbeitskopie)
@@ -16,54 +16,55 @@
       <action>PLUGIN mythmusic</action>
       <depends>mythmusic</depends>	
    </button>
-   
+
    <button>
-     <type>VIDEO_MANAGER</type>
-     <text>Video Manager</text>
-     <text lang="ES">Gestionar vÃ­deos</text>
-     <text lang="CA">Gestionar vÃ­deos</text>
-     <text lang="DK">Film opsÃ¦tning</text>
-     <text lang="DE">Videos verwalten</text>
-     <text lang="PT">Gerir Filmes</text>
-     <text lang="SV">Filmhanterare</text>
-     <text lang="FR">Gestionnaire de vidéos</text>
-     <text lang="NL">Video's Beheren</text>
-     <text lang="JA">ビデオマネージャー</text>
-     <text lang="FI">Videonhallinta</text>
-     <text lang="ZH_TW">電影工具</text>
-     <text lang="SI">Video manager</text>
-     <text lang="ET">Videohaldus</text>
-     <text lang="NB">Videobehandler</text>
-     <action>JUMP Video Manager</action>
-     <depends>mythvideo</depends>
+      <type>VIDEO_MANAGER</type>
+      <text>Video Manager</text>
+      <text lang="ES">Gestionar vÃ­deos</text>
+      <text lang="CA">Gestionar vÃ­deos</text>
+      <text lang="DK">Film opsÃ¦tning</text>
+      <text lang="DE">Videos verwalten</text>
+      <text lang="PT">Gerir Filmes</text>
+      <text lang="SV">Filmhanterare</text>
+      <text lang="FR">Gestionnaire de vidéos</text>
+      <text lang="NL">Video's Beheren</text>
+      <text lang="JA">ビデオマネージャー</text>
+      <text lang="FI">Videonhallinta</text>
+      <text lang="ZH_TW">電影工具</text>
+      <text lang="SI">Video manager</text>
+      <text lang="ET">Videohaldus</text>
+      <text lang="NB">Videobehandler</text>
+      <action>JUMP Video Manager</action>
+      <depends>mythvideo</depends>
    </button>
     
-    <button>
+   <button>
       <type>SETUP_KEYS</type>
       <text>Edit Keys</text>
+      <text lang="DE">Tastenbelegung ändern</text>
       <action>PLUGIN mythcontrols</action>
       <depends>mythcontrols</depends>	
    </button>
       
    <button>
-     <type>SETUP_MENU</type>
-     <text>Setup</text>
-     <text lang="IT">Impostazioni</text>
-     <text lang="ES">Configurar</text>
-     <text lang="CA">Configurar</text>
-     <text lang="FR">Configuration</text>
-     <text lang="DE">Konfiguration</text>
-     <text lang="DK">Konfiguration</text>
-     <text lang="NL">Instellingen</text>
-     <text lang="PT">Configurações</text>
-     <text lang="SV">Inställningar</text>
-     <text lang="JA">設定</text>
-     <text lang="FI">Asetukset</text>
-     <text lang="ZH_TW">設定</text>
-     <text lang="SI">Nastavitve</text>
-     <text lang="ET">Seaded</text>
-     <text lang="NB">Innstillinger</text>
-     <action>MENU main_settings.xml</action>
+      <type>SETUP_MENU</type>
+      <text>Setup</text>
+      <text lang="IT">Impostazioni</text>
+      <text lang="ES">Configurar</text>
+      <text lang="CA">Configurar</text>
+      <text lang="FR">Configuration</text>
+      <text lang="DE">Konfiguration</text>
+      <text lang="DK">Konfiguration</text>
+      <text lang="NL">Instellingen</text>
+      <text lang="PT">Configurações</text>
+      <text lang="SV">Inställningar</text>
+      <text lang="JA">設定</text>
+      <text lang="FI">Asetukset</text>
+      <text lang="ZH_TW">設定</text>
+      <text lang="SI">Nastavitve</text>
+      <text lang="ET">Seaded</text>
+      <text lang="NB">Innstillinger</text>
+      <action>MENU main_settings.xml</action>
    </button>
 
 </mythmenu>
Index: themes/DVR/util_menu.xml
===================================================================
--- themes/DVR/util_menu.xml	(Revision 6964)
+++ themes/DVR/util_menu.xml	(Arbeitskopie)
@@ -178,6 +178,7 @@
     <button>
       <type>SETUP_KEYS</type>
       <text>Edit Keys</text>
+      <text lang="DE">Tastenbelegung ändern</text>
       <action>PLUGIN mythcontrols</action>
       <depends>mythcontrols</depends>
    </button>