Index: themes/G.A.N.T./ui.xml
===================================================================
--- themes/G.A.N.T./ui.xml	(revision 7004)
+++ themes/G.A.N.T./ui.xml	(working copy)
@@ -239,6 +239,25 @@
         <catcolor category="社会・報道" color="DarkOrange3"></catcolor>
         <catcolor category="趣味・暮らし" color="goldenrod"></catcolor>
 
+        <!-- Categories introduced by tv_grab_br -->
+        <catcolor category="Educativo" color="CornflowerBlue"></catcolor>
+        <catcolor category="Infantil" color="MediumSlateBlue"></catcolor>
+        <catcolor category="Desenho" color="MediumSlateBlue"></catcolor>
+        <catcolor category="Juvenil" color="SlateBlue"></catcolor>
+        <catcolor category="Religião" color="goldenrod"></catcolor>
+        <catcolor category="Esportivo" color="DarkCyan"></catcolor>
+        <catcolor category="Competição" color="DarkCyan"></catcolor>
+        <catcolor category="Futebol" color="DarkCyan"></catcolor>
+        <catcolor category="Cinema" color="Blue"></catcolor>
+        <catcolor category="Drama" color="rosybrown3"></catcolor>
+        <catcolor category="Ação" color="maroon"></catcolor>
+        <catcolor category="Humor" color="DarkOrchid"></catcolor>
+        <catcolor category="Suspense" color="SlateGrey"></catcolor>
+        <catcolor category="Informativo" color="DarkOrange3"></catcolor>
+        <catcolor category="Política" color="DarkOrange3"></catcolor>
+        <catcolor category="Musical" color="turquoise3"></catcolor>
+        <catcolor category="Ecologia" color="ForestGreen"></catcolor>
+        <catcolor category="Novela" color="MediumTurquoise"></catcolor>
 
         <recordstatus type="SingleRecord" image="gg-rs-single.png"></recordstatus>
         <recordstatus type="TimeslotRecord" image="gg-rs-timeslot.png"></recordstatus>
@@ -543,6 +562,26 @@
         <catcolor category="社会・報道" color="DarkOrange3"></catcolor>
         <catcolor category="趣味・暮らし" color="goldenrod"></catcolor>
 
+        <!-- Categories introduced by tv_grab_br -->
+        <catcolor category="Educativo" color="CornflowerBlue"></catcolor>
+        <catcolor category="Infantil" color="MediumSlateBlue"></catcolor>
+        <catcolor category="Desenho" color="MediumSlateBlue"></catcolor>
+        <catcolor category="Juvenil" color="SlateBlue"></catcolor>
+        <catcolor category="Religião" color="goldenrod"></catcolor>
+        <catcolor category="Esportivo" color="DarkCyan"></catcolor>
+        <catcolor category="Competição" color="DarkCyan"></catcolor>
+        <catcolor category="Futebol" color="DarkCyan"></catcolor>
+        <catcolor category="Cinema" color="Blue"></catcolor>
+        <catcolor category="Drama" color="rosybrown3"></catcolor>
+        <catcolor category="Ação" color="maroon"></catcolor>
+        <catcolor category="Humor" color="DarkOrchid"></catcolor>
+        <catcolor category="Suspense" color="SlateGrey"></catcolor>
+        <catcolor category="Informativo" color="DarkOrange3"></catcolor>
+        <catcolor category="Política" color="DarkOrange3"></catcolor>
+        <catcolor category="Musical" color="turquoise3"></catcolor>
+        <catcolor category="Ecologia" color="ForestGreen"></catcolor>
+        <catcolor category="Novela" color="MediumTurquoise"></catcolor>
+
         <recordstatus type="SingleRecord" image="gg-rs-single.png"></recordstatus>
         <recordstatus type="TimeslotRecord" image="gg-rs-timeslot.png"></recordstatus>
         <recordstatus type="ChannelRecord" image="gg-rs-channel.png"></recordstatus>
Index: themes/blue/ui.xml
===================================================================
--- themes/blue/ui.xml	(revision 7004)
+++ themes/blue/ui.xml	(working copy)
@@ -231,6 +231,26 @@
         <catcolor category="社会・報道" color="DarkOrange3"></catcolor>
         <catcolor category="趣味・暮らし" color="goldenrod"></catcolor>
 
+        <!-- Categories introduced by tv_grab_br -->
+        <catcolor category="Educativo" color="CornflowerBlue"></catcolor>
+        <catcolor category="Infantil" color="MediumSlateBlue"></catcolor>
+        <catcolor category="Desenho" color="MediumSlateBlue"></catcolor>
+        <catcolor category="Juvenil" color="SlateBlue"></catcolor>
+        <catcolor category="Religião" color="goldenrod"></catcolor>
+        <catcolor category="Esportivo" color="DarkCyan"></catcolor>
+        <catcolor category="Competição" color="DarkCyan"></catcolor>
+        <catcolor category="Futebol" color="DarkCyan"></catcolor>
+        <catcolor category="Cinema" color="Blue"></catcolor>
+        <catcolor category="Drama" color="rosybrown3"></catcolor>
+        <catcolor category="Ação" color="maroon"></catcolor>
+        <catcolor category="Humor" color="DarkOrchid"></catcolor>
+        <catcolor category="Suspense" color="SlateGrey"></catcolor>
+        <catcolor category="Informativo" color="DarkOrange3"></catcolor>
+        <catcolor category="Política" color="DarkOrange3"></catcolor>
+        <catcolor category="Musical" color="turquoise3"></catcolor>
+        <catcolor category="Ecologia" color="ForestGreen"></catcolor>
+        <catcolor category="Novela" color="MediumTurquoise"></catcolor>
+
         <recordstatus type="SingleRecord" image="gg-rs-single.png"></recordstatus>
         <recordstatus type="TimeslotRecord" image="gg-rs-timeslot.png"></recordstatus>
         <recordstatus type="ChannelRecord" image="gg-rs-channel.png"></recordstatus>
@@ -514,6 +534,25 @@
         <catcolor category="社会・報道" color="DarkOrange3"></catcolor>
         <catcolor category="趣味・暮らし" color="goldenrod"></catcolor>
 
+        <!-- Categories introduced by tv_grab_br -->
+        <catcolor category="Educativo" color="CornflowerBlue"></catcolor>
+        <catcolor category="Infantil" color="MediumSlateBlue"></catcolor>
+        <catcolor category="Desenho" color="MediumSlateBlue"></catcolor>
+        <catcolor category="Juvenil" color="SlateBlue"></catcolor>
+        <catcolor category="Religião" color="goldenrod"></catcolor>
+        <catcolor category="Esportivo" color="DarkCyan"></catcolor>
+        <catcolor category="Competição" color="DarkCyan"></catcolor>
+        <catcolor category="Futebol" color="DarkCyan"></catcolor>
+        <catcolor category="Cinema" color="Blue"></catcolor>
+        <catcolor category="Drama" color="rosybrown3"></catcolor>
+        <catcolor category="Ação" color="maroon"></catcolor>
+        <catcolor category="Humor" color="DarkOrchid"></catcolor>
+        <catcolor category="Suspense" color="SlateGrey"></catcolor>
+        <catcolor category="Informativo" color="DarkOrange3"></catcolor>
+        <catcolor category="Política" color="DarkOrange3"></catcolor>
+        <catcolor category="Musical" color="turquoise3"></catcolor>
+        <catcolor category="Ecologia" color="ForestGreen"></catcolor>
+        <catcolor category="Novela" color="MediumTurquoise"></catcolor>
 
         <recordstatus type="SingleRecord" image="gg-rs-single.png"></recordstatus>
         <recordstatus type="TimeslotRecord" image="gg-rs-timeslot.png"></recordstatus>
Index: libs/libmythtv/videosource.cpp
===================================================================
--- libs/libmythtv/videosource.cpp	(revision 7004)
+++ libs/libmythtv/videosource.cpp	(working copy)
@@ -679,7 +679,9 @@
         grabber == "tv_grab_nl" || grabber == "tv_grab_jp" ||
         grabber == "tv_grab_no" || grabber == "tv_grab_pt" ||
         grabber == "tv_grab_ee" || grabber == "tv_grab_be_tvb" ||
-        grabber == "tv_grab_be_tlm" || grabber == "tv_grab_is")
+        grabber == "tv_grab_be_tlm" || grabber == "tv_grab_is" ||
+        grabber == "tv_grab_br")
+        
     {
         cerr << "You _MUST_ run 'mythfilldatabase --manual the first time, "
              << "instead\n";
@@ -765,6 +767,9 @@
 
     addTarget("tv_grab_is", new XMLTV_generic_config(parent, "tv_grab_is"));
     grabber->addSelection("Iceland", "tv_grab_is");
+
+    addTarget("tv_grab_br", new XMLTV_generic_config(parent, "tv_grab_br"));
+    grabber->addSelection("Brazil", "tv_grab_br");
 }
 
 VideoSource::VideoSource() 
Index: programs/mythfilldatabase/filldata.cpp
===================================================================
--- programs/mythfilldatabase/filldata.cpp	(revision 7004)
+++ programs/mythfilldatabase/filldata.cpp	(working copy)
@@ -2818,7 +2818,8 @@
                  xmltv_grabber == "tv_grab_de_tvtoday" ||
                  xmltv_grabber == "tv_grab_be_tvb" ||
                  xmltv_grabber == "tv_grab_be_tlm" ||
-                 xmltv_grabber == "tv_grab_is")
+                 xmltv_grabber == "tv_grab_is" ||
+                 xmltv_grabber == "tv_grab_br")
         {
             if (xmltv_grabber == "tv_grab_no")
                 listing_wrap_offset = 6 * 3600;