Index: mythdvd/i18n/mythdvd_nl.ts
===================================================================
--- mythdvd/i18n/mythdvd_nl.ts	(revision 7064)
+++ mythdvd/i18n/mythdvd_nl.ts	(working copy)
@@ -293,11 +293,11 @@
     </message>
     <message>
         <source>ISO copy of %1</source>
-        <translation type="unfinished"></translation>
+        <translation>ISO kopie van %1</translation>
     </message>
     <message>
         <source>Waiting for access to DVD</source>
-        <translation type="unfinished"></translation>
+        <translation>Aan het wachten op toegang tot de DVD</translation>
     </message>
 </context>
 <context>
@@ -383,7 +383,7 @@
     </message>
     <message>
         <source>ISO Image</source>
-        <translation type="unfinished"></translation>
+        <translation>ISO Kopie</translation>
     </message>
 </context>
 </TS>
Index: mythmusic/i18n/mythmusic_nl.ts
===================================================================
--- mythmusic/i18n/mythmusic_nl.ts	(revision 7064)
+++ mythmusic/i18n/mythmusic_nl.ts	(working copy)
@@ -87,7 +87,7 @@
     </message>
     <message>
         <source>The theme you are using does not contain any info lines in the music element.  Please contact the theme creator and ask if they could please update it.&lt;br&gt;&lt;br&gt;The next screen will be empty.  Escape out of it to return to the menu.</source>
-        <translation type="unfinished"></translation>
+        <translation>Het thema dat u gebruikt bevat geen informatie in het music element. Neem contact op met de maker van dit thema en vraag of ze het thema willen aanpassen.&lt;br&gt;&lt;br&gt;Het volgende scherm zal leeg zijn. Ga eruit om terug te gaan naar het menu.</translation>
     </message>
     <message>
         <source>Artist:<byte value="x9"/></source>
@@ -107,7 +107,7 @@
     </message>
     <message>
         <source>Genre: </source>
-        <translation type="unfinished"></translation>
+        <translation>Genre: </translation>
     </message>
     <message>
         <source>Compilation Artist:<byte value="x9"/></source>
@@ -981,15 +981,15 @@
     </message>
     <message>
         <source>CD: %1 ~ %2 - %3</source>
-        <translation type="unfinished"></translation>
+        <translation>CD: %1 ~ %2 - %3</translation>
     </message>
     <message>
         <source>Track %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Track %1</translation>
     </message>
     <message>
         <source>Order in which to sort the Music Tree. Possible values are a space-separated list of genre, splitartist, splitartist1, artist, album, and title OR the keyword &quot;directory&quot; to indicate that the onscreen tree mirrors the filesystem.</source>
-        <translation type="unfinished"></translation>
+        <translation>Volgorde waarin de muziek boom moet worden gesorteerd. Mogelijk waarden zijn een spatie-gescheiden lijst van: genre, splitartist, splitartist1, artist, album, en title OF het woord &quot;directory&quot; om aan te geven dat op het scherm het bestandssysteem moet worden weergegeven.</translation>
     </message>
 </context>
 <context>
@@ -1069,11 +1069,11 @@
     </message>
     <message>
         <source>Quality: </source>
-        <translation type="unfinished"></translation>
+        <translation>Kwaliteit: </translation>
     </message>
     <message>
         <source>Importing </source>
-        <translation type="unfinished"></translation>
+        <translation>Bezig met importeren </translation>
     </message>
 </context>
 <context>
@@ -1096,50 +1096,50 @@
     </message>
     <message>
         <source>Select a Compilation Artist</source>
-        <translation type="unfinished">Kies een Compilatie Artiest</translation>
+        <translation>Kies een Compilatie Artiest</translation>
     </message>
 </context>
 <context>
     <name>SmartPLDateDialog</name>
     <message>
         <source>Edit Date</source>
-        <translation type="unfinished"></translation>
+        <translation>Bewerkings datum</translation>
     </message>
     <message>
         <source>Fixed Date</source>
-        <translation type="unfinished"></translation>
+        <translation>Vaste datum</translation>
     </message>
     <message>
         <source>Day</source>
-        <translation type="unfinished"></translation>
+        <translation>Dag</translation>
     </message>
     <message>
         <source>Month</source>
-        <translation type="unfinished"></translation>
+        <translation>Maand</translation>
     </message>
     <message>
         <source>Year</source>
-        <translation type="unfinished">Jaar</translation>
+        <translation>Jaar</translation>
     </message>
     <message>
         <source>Use Current Date</source>
-        <translation type="unfinished"></translation>
+        <translation>Gebruik de huidige datum</translation>
     </message>
     <message>
         <source>+/- Days</source>
-        <translation type="unfinished"></translation>
+        <translation>+/- Dagen</translation>
     </message>
     <message>
         <source>OK</source>
-        <translation type="unfinished">OK</translation>
+        <translation>OK</translation>
     </message>
     <message>
         <source>Cancel</source>
-        <translation type="unfinished"></translation>
+        <translation>Annuleer</translation>
     </message>
     <message>
         <source>Invalid Date</source>
-        <translation type="unfinished"></translation>
+        <translation>Ongeldige datum</translation>
     </message>
 </context>
 <context>
@@ -1202,7 +1202,7 @@
     </message>
     <message>
         <source>OK</source>
-        <translation type="unfinished">OK</translation>
+        <translation>OK</translation>
     </message>
 </context>
 <context>
@@ -1217,7 +1217,7 @@
     </message>
     <message>
         <source>ID</source>
-        <translation type="unfinished"></translation>
+        <translation>ID</translation>
     </message>
     <message>
         <source>Artist</source>
@@ -1331,7 +1331,7 @@
     </message>
     <message>
         <source></source>
-        <translation type="unfinished"></translation>
+        <translation></translation>
     </message>
     <message>
         <source>Cancel</source>
@@ -1347,7 +1347,7 @@
     </message>
     <message>
         <source>Smart Playlist Categories</source>
-        <translation>Categrien Van Slimme Speellijsten</translation>
+        <translation>Categorien Van Slimme Speellijsten</translation>
     </message>
     <message>
         <source>New Category</source>
Index: settings.pro
===================================================================
--- settings.pro	(revision 7064)
+++ settings.pro	(working copy)
@@ -6,9 +6,9 @@
 INCLUDEPATH += $${PREFIX}/include
 #INCLUDEPATH += /usr/include/cdda
 #INCLUDEPATH += /usr/include/FLAC
-INCLUDEPATH += /usr/kde/3.3/include
+INCLUDEPATH += /usr/kde/3.4/include
 
-LIBPATH += /usr/kde/3.3/lib
+LIBPATH += /usr/kde/3.4/lib
 LIBS *= -L$${PREFIX}/lib
 
 DEFINES += _GNU_SOURCE
Index: mythgallery/i18n/mythgallery_nl.ts
===================================================================
--- mythgallery/i18n/mythgallery_nl.ts	(revision 7064)
+++ mythgallery/i18n/mythgallery_nl.ts	(working copy)
@@ -98,7 +98,7 @@
     </message>
     <message>
         <source>Random</source>
-        <translation type="unfinished"></translation>
+        <translation>Willekeurig</translation>
     </message>
 </context>
 <context>
@@ -173,27 +173,27 @@
     </message>
     <message>
         <source>Command run to display movie files</source>
-        <translation type="unfinished"></translation>
+        <translation>Command om video bestanden te spelen</translation>
     </message>
     <message>
         <source>This command is executed whenever a movie file is selected</source>
-        <translation type="unfinished"></translation>
+        <translation>Dit commando wordt gebruikt om een video bestand te spelen</translation>
     </message>
     <message>
         <source>Store thumbnails in image directory</source>
-        <translation type="unfinished"></translation>
+        <translation>Sla voorbeeld plaatjes op in de image directory</translation>
     </message>
     <message>
         <source>If set, thumbnails are stored in &apos;.thumbcache&apos; directories within the above directory. If cleared, they are stored in your home directory.</source>
-        <translation type="unfinished"></translation>
+        <translation>Als dit is ingevuld, worden de voorbeeld plaatjes opgeslagen in &apos;.thumbcache&apos; directories binnen bovenstaande directory. Als het niet is ingevuld, worden ze bewaard in uw home directory.</translation>
     </message>
     <message>
         <source>Recurse into directories</source>
-        <translation type="unfinished"></translation>
+        <translation>Ga recursief door alle directories</translation>
     </message>
     <message>
         <source>Check this to let the slideshow recurse into sub-directories.</source>
-        <translation type="unfinished"></translation>
+        <translation>Zet dit aan zodat de dia-show ook alle subdirectories laat zien.</translation>
     </message>
 </context>
 <context>