Index: docs/mythtv-HOWTO.sgml
===================================================================
--- docs/mythtv-HOWTO.sgml	(revision 7276)
+++ docs/mythtv-HOWTO.sgml	(working copy)
@@ -2937,7 +2937,7 @@
 
 For synchronous TV-out: check Deinterlace with "Bob (2x framerate)"
  
-<sect1>Recording 
+<sect1>Recording <label id="Recording">
 <p>Depending on your capture card, MythTV offers different video encoders. 
 The following types of hardware encoding cards are supported:
 <itemize>
@@ -3621,9 +3621,9 @@
 set-wakeuptime-script should stop the program that uses <tt>/dev/rtc</tt> before
 setting the wakeuptime.
 
-<sect1>Scheduling Recordings
+<sect>Scheduling Recordings
 <p>The MythTV master backend is responsible for managing the schedule
-for all TV tuner cards on the master and any slave. It's job is to
+for all TV tuner cards on the master and any slave. Its job is to
 search the TV listing for the shows you have requested and assign
 recordings to the TV tuner cards. If none of the shows that you've
 chosen overlap, it simply records all of the shows. However, if
@@ -3634,7 +3634,7 @@
 specific decisions about what you really do and don't want to
 record.
 
-<sect2>Record Types
+<sect1>Record Types
 <p>When you choose a show that you would like to record from the
 Options Page, there are eight different types of rules to help the
 scheduler find which showings you would like to record.
@@ -3689,48 +3689,10 @@
 station when the original airing cannot be recorded.
 </itemize>
 
-<sect2>Duplicates
-<p>Singles will record without regard to duplicate matching.
+<sect1>Scheduling Options
 
-<p>The standard recurring methods of All, Channel, Weekly and Daily use
-the descriptive information in the TV listings to try to record only one
-showing of each unique episode. However, This goal is sometimes
-complicated by the fact that the stations may not include a description
-for a specific episode but use a generic description for the series
-instead. When there is a generic description, the default behavior is to
-assume that it may be an episode that you have not seen and to record it
-for you.  One of the duplicate matching options is "Record new episodes
-only".  If this is selected, listing that have an original air date of
-more than 14 days earlier are considered repeats and are not eligible to
-record. Generally, generic episodes will be marked as repeats also.
-
-<p>Because of generic episodes and other situations, MythTV offers an
-alternative approach where shows may be recorded by choosing from
-multiple showings even when the descriptive information is not reliable.
-All of the "Find" record types look for matching titles in the
-listings. If there is a showing with specific episode information and
-that episode has recorded before, that showing is marked as previously
-or currently recorded. The scheduler will then choose to record the
-earliest non-conflicting showing from any of other remaining showings
-regardless of the descriptive information. Generally, Find One is most
-useful for movies or specials and the Find Daily and Find Weekly rules
-are best for news or current events shows that are repeated. However,
-these may be useful in other situations where the standard recording
-rules may not work correctly.
-
-<sect2>Conflicts
-<p>As you add more shows that you would like to record, the scheduler
-will eventually encounter conflicts. If there are two shows at the
-same time and you have two or more TV tuner cards, both shows will
-record. However, if there are more shows than cards, the scheduler
-will have to decide what it thinks it should not record based on the
-information you have given. If you see an unexpected situation you
-are not "stuck" with the scheduler's choice. You can still tell the
-scheduler exactly which shows you do want to record and/or don't
-want to record in any situation.
-
 <sect2>Priority
-<p>By default, all shows you select are have equal value to the
+<p>By default, all shows you select have equal value to the
 scheduler.  There are a set of rules to make good choices when
 two or more shows are in conflict. However, priority values let the
 scheduler know what you want so that it can set the schedule based
@@ -3794,6 +3756,50 @@
 priority that the scheduler uses to decide which shows are given the
 first choice when filling in the schedule.
 
+The scheduling priority of a show may also be used to determine
+auto-expiration of recordings when disk space gets full (see <ref
+id="Auto-Expire" name="Auto-Expire">, below).
+
+<sect2>Duplicates
+<p>Singles will record without regard to duplicate matching.
+
+<p>The standard recurring methods of All, Channel, Weekly and Daily use
+the descriptive information in the TV listings to try to record only one
+showing of each unique episode. However, This goal is sometimes
+complicated by the fact that the stations may not include a description
+for a specific episode but use a generic description for the series
+instead. When there is a generic description, the default behavior is to
+assume that it may be an episode that you have not seen and to record it
+for you.  One of the duplicate matching options is "Record new episodes
+only".  If this is selected, listing that have an original air date of
+more than 14 days earlier are considered repeats and are not eligible to
+record. Generally, generic episodes will be marked as repeats also.
+
+<p>Because of generic episodes and other situations, MythTV offers an
+alternative approach where shows may be recorded by choosing from
+multiple showings even when the descriptive information is not reliable.
+All of the "Find" record types look for matching titles in the
+listings. If there is a showing with specific episode information and
+that episode has recorded before, that showing is marked as previously
+or currently recorded. The scheduler will then choose to record the
+earliest non-conflicting showing from any of other remaining showings
+regardless of the descriptive information. Generally, Find One is most
+useful for movies or specials and the Find Daily and Find Weekly rules
+are best for news or current events shows that are repeated. However,
+these may be useful in other situations where the standard recording
+rules may not work correctly.
+
+<sect2>Conflicts
+<p>As you add more shows that you would like to record, the scheduler
+will eventually encounter conflicts. If there are two shows at the
+same time and you have two or more TV tuner cards, both shows will
+record. However, if there are more shows than cards, the scheduler
+will have to decide what it thinks it should not record based on the
+information you have given. If you see an unexpected situation you
+are not "stuck" with the scheduler's choice. You can still tell the
+scheduler exactly which shows you do want to record and/or don't
+want to record in any situation.
+
 <sect2>Scheduling decisions
 <p>Here are the actual decisions made by the scheduler as it fills in the
 schedule.
@@ -3930,6 +3936,87 @@
 it very easy to try out some "what if" attempts when deciding on your best
 strategy in a difficult situation.
 
+<sect1>Storage Options
+<sect2>Recording Profile
+<p>Each schedule can be configured with a different recording profile.
+For example, important shows can be configured with a "High Quality"
+profile, while "filler" shows can be configured with a "Low Quality"
+profile. These recording profiles need to be configured first (see
+<ref id="Recording" name="Recording">, above).
+
+<sect2>Recording Group <label id="Recording Group">
+<p>For organization of the "Watch Recordings" screen and the MythWeb
+interface, recordings can be grouped into "recording groups".
+
+<sect2>Time Stretch
+<p>A default time stretch value can be configured for each schedule;
+this value will automatically be applied when the recordings are
+played back.
+
+<sect2>Auto-Expire <label id="Auto-Expire">
+<p>MythTV will "autoexpire" old recordings to make room for new recordings
+when disk space gets filled up. This option can be set to "Don't allow
+auto expire" to prevent recordings from being automatically deleted
+when disk space fills up.
+
+<p>The default setting is for all scheduled recordings to be eligible
+for auto-expiration; this can be changed in the Settings->TV
+Settings->General page by manipulating the "Auto Expire Default"
+checkbox.
+
+<p>The default auto-expire policy is "Oldest Show First"; the oldest
+recordings are deleted first. The "Lowest Priority First" method
+chooses to expire the lowest-priority recordings first.
+
+<sect2>Episode Limit
+<p>An episode limit can also be configured to limit the maximum number
+of episodes recorded of a single series, to restrict that series' disk
+usage. If this is set, you can further decide what to do when this
+limit is reached: either stop recording that series, or to delete the
+oldest episodes in favor of the new ones.
+
+<sect1>Post Recording Processing
+<sect2>Commercial Flagging
+<p>Select whether or not to automatically flag commercials for these
+recordings. Commercial Flagging parameters can be set in
+Setup->TV Settings->General.
+
+<sect2>Transcoding
+<p>Select whether or not to automatically transcode recordings to save
+disk space. Before using this, you must first enable auto-transcode in
+the recording profile and configure the transcoding parameters; see
+<ref id="Recording" name="Recording">, above.
+
+<sect2>User Jobs
+<p>User Jobs allow you to configure up to 4 custom commands to run on
+recordings. They can be configured in mythtv-setup. The following
+tokens have special meaning when used in the User Job commands:
+
+<itemize>
+<item>%DIR% - the directory component of the recording's filename
+<item>%FILE% - the filename component of the recording's filename
+<item>%TITLE% - the title of the recording (e.g., name of the series)
+<item>%SUBTITLE% - the subtitle of the recording (e.g., name of the
+episode)
+<item>%DESCRIPTION% - description text for the recording (from guide
+data)
+<item>%HOSTNAME% - the backend making the recording
+<item>%CATEGORY% - the category of the recording (from guide data)
+<item>%RECGROUP% - the <ref id="Recording Group" name="recording
+group">
+<item>%CHANID% - the MythTV channel ID making the recording
+<item>%STARTTIME% - the recording start time (YYYYMMDDhhmmss)
+<item>%ENDTIME% - the recording end time (YYYYMMDDhhmmss)
+<item>%STARTTIMEISO% - the recording start time in ISO 8601 format
+(YYYY-MM-DDTHH:MM:SS)
+<item>%ENDTIMEISO% - the recording end time in ISO 8601 format
+<item>%PROGSTART% - the recording's start time (from guide data;
+YYYYMMDDhhmmss)
+<item>%PROGEND% - the recording's end time (from guide data)
+<item>%PROGSTARTISO%, %PROGENDISO% - the recording's start and end
+time in ISO 8601 format.
+</itemize>
+
 <sect1>Advanced Recording Options
 <p>Creating Power Search rules with Custom Record
 