Index: includes/programs.php
===================================================================
--- includes/programs.php	(revision 7276)
+++ includes/programs.php	(working copy)
@@ -14,12 +14,12 @@
                               '-7' => 'LowDiskSpace',
                               '-6' => 'Cancelled',
                               '-5' => 'Deleted',
-                              '-4' => 'Stopped',
+                              '-4' => 'Aborted',
                               '-3' => 'Recorded',
                               '-2' => 'Recording',
                               '-1' => 'WillRecord',
                                 0  => 'Unknown',
-                                1  => 'ManualOverride',
+                                1  => 'DontRecord',
                                 2  => 'PreviousRecording',
                                 3  => 'CurrentRecording',
                                 4  => 'EarlierShowing',
@@ -28,7 +28,7 @@
                                 7  => 'Conflict',
                                 8  => 'LaterShowing',
                                 9  => 'Repeat',
-                                10 => 'Overlap',
+                                10 => 'Inactive',
                                 11 => 'NeverRecord'
                             );
 
@@ -37,12 +37,12 @@
                                'LowDiskSpace'       => t('recstatus: lowdiskspace'),
                                'Cancelled'          => t('recstatus: cancelled'),
                                'Deleted'            => t('recstatus: deleted'),
-                               'Stopped'            => t('recstatus: stopped'),
+                               'Aborted'            => t('recstatus: stopped'),
                                'Recorded'           => t('recstatus: recorded'),
                                'Recording'          => t('recstatus: recording'),
                                'WillRecord'         => t('recstatus: willrecord'),
                                'Unknown'            => t('recstatus: unknown'),
-                               'ManualOverride'     => t('recstatus: manualoverride'),
+                               'DontRecord'         => t('recstatus: manualoverride'),
                                'PreviousRecording'  => t('recstatus: previousrecording'),
                                'CurrentRecording'   => t('recstatus: currentrecording'),
                                'EarlierShowing'     => t('recstatus: earliershowing'),
@@ -51,7 +51,7 @@
                                'Conflict'           => t('recstatus: conflict'),
                                'Repeat'             => t('recstatus: repeat'),
                                'LaterShowing'       => t('recstatus: latershowing'),
-                               'Overlap'            => t('recstatus: overlap'),
+                               'Inactive'           => t('recstatus: inactive'),
                                'NeverRecord'        => t('recstatus: neverrecord'),
                             // A special category for mythweb, since this feature doesn't exist in the backend
                                'ForceRecord'        => t('recstatus: force_record'),
Index: languages/English.php
===================================================================
--- languages/English.php	(revision 7276)
+++ languages/English.php	(working copy)
@@ -119,6 +119,7 @@
     'recstatus: deleted'           => 'This showing was recorded but was deleted before recording was completed.',
     'recstatus: earliershowing'    => 'This episode will be recorded at an earlier time instead.',
     'recstatus: force_record'      => 'This show was manually set to record this specific instance.',
+    'recstatus: inactive'          => 'This recording schedule is inactive.',
     'recstatus: latershowing'      => 'This episode will be recorded at a later time instead.',
     'recstatus: lowdiskspace'      => 'There wasn\'t enough disk space available to record this program.',
     'recstatus: manualoverride'    => 'This showing was manually set to not record',