Index: i18n/mythfrontend_fi.ts
===================================================================
--- i18n/mythfrontend_fi.ts	(revision 7679)
+++ i18n/mythfrontend_fi.ts	(working copy)
@@ -121,34 +121,34 @@
     </message>
     <message>
         <source>Are you sure you want to delete ALL capture cards?</source>
-        <translation type="unfinished"></translation>
+        <translation>Poistetaanko KAIKKIEN TV-korttien asetukset?</translation>
     </message>
     <message>
         <source>Yes, delete capture cards</source>
-        <translation type="unfinished"></translation>
+        <translation>Kyllä, poista</translation>
     </message>
 </context>
 <context>
     <name>CardInput</name>
     <message>
         <source>Scan for channels</source>
-        <translation type="unfinished"></translation>
+        <translation>Etsi kanavia</translation>
     </message>
     <message>
         <source>Use channel scanner to find channels for this input.</source>
-        <translation type="unfinished"></translation>
+        <translation>Käyttää kanavaselainta tämän sisääntulon kanavien etsintään.</translation>
     </message>
     <message>
         <source>Fetch channels from listings source</source>
-        <translation type="unfinished"></translation>
+        <translation>Hae kanavat tekstilähteestä</translation>
     </message>
     <message>
         <source>This uses the listings data source to provide the channels for this input.</source>
-        <translation type="unfinished"></translation>
+        <translation>Käyttää tekstipohjaista dokumenttia kanavien virittämiseen.</translation>
     </message>
     <message>
         <source>This can take a long time to run.</source>
-        <translation type="unfinished"></translation>
+        <translation>Voi kestää jonkin aikaa.</translation>
     </message>
 </context>
 <context>
@@ -183,19 +183,19 @@
     </message>
     <message>
         <source>Delete Channels</source>
-        <translation type="unfinished"></translation>
+        <translation>Kanavien Poistaminen</translation>
     </message>
     <message>
         <source>Delete all channels on currently selected source[s].</source>
-        <translation type="unfinished"></translation>
+        <translation>Poista kaikki nykyis[t]en ohjelmalähteen/lähteiden kanavat.</translation>
     </message>
     <message>
         <source>Are you sure you would like to delete these channels?</source>
-        <translation type="unfinished"></translation>
+        <translation>Poistetaanko nämä kanavat?</translation>
     </message>
     <message>
         <source>Yes, delete the channels</source>
-        <translation type="unfinished"></translation>
+        <translation>Kyllä, poista</translation>
     </message>
 </context>
 <context>
@@ -364,11 +364,11 @@
     <name>DTVSignalMonitor</name>
     <message>
         <source>Seen</source>
-        <translation type="unfinished"></translation>
+        <translation>Nähty</translation>
     </message>
     <message>
         <source>Matching</source>
-        <translation type="unfinished"></translation>
+        <translation>Sopiva</translation>
     </message>
 </context>
 <context>
@@ -379,7 +379,7 @@
     </message>
     <message>
         <source>Recording Options</source>
-        <translation type="unfinished">Nauhoitusasetukset</translation>
+        <translation>Nauhoitusasetukset</translation>
     </message>
 </context>
 <context>
@@ -1129,23 +1129,23 @@
     </message>
     <message>
         <source>Disable Auto Expire</source>
-        <translation type="unfinished"></translation>
+        <translation>Poista Käytöstä Automaattinen Vanhentuminen</translation>
     </message>
     <message>
         <source>Enable Auto Expire</source>
-        <translation type="unfinished"></translation>
+        <translation>Salli Automaattinen Vanhentuminen</translation>
     </message>
     <message>
         <source>Change Recording Title</source>
-        <translation type="unfinished"></translation>
+        <translation>Vaihda Nauhoituksen Nimikettä</translation>
     </message>
     <message>
         <source>Title</source>
-        <translation type="unfinished">Nimi</translation>
+        <translation>Nimike</translation>
     </message>
     <message>
         <source>Subtitle</source>
-        <translation type="unfinished"></translation>
+        <translation>Jakson Kuvaus</translation>
     </message>
 </context>
 <context>
@@ -6828,7 +6828,7 @@
     </message>
     <message>
         <source>DBOX2 Streaming Port</source>
-        <translation type="unfinished"></translation>
+        <translation>DBOX2 Lähetysportti</translation>
     </message>
     <message>
         <source>DBOX2 streaming port on your DBOX2.</source>
@@ -6836,7 +6836,7 @@
     </message>
     <message>
         <source>DBOX2 HTTP Port</source>
-        <translation type="unfinished"></translation>
+        <translation>DBOX2 HTTP-portti</translation>
     </message>
     <message>
         <source>DBOX2 http port on your DBOX2.</source>
@@ -6844,7 +6844,7 @@
     </message>
     <message>
         <source>DBOX2 Host IP</source>
-        <translation type="unfinished"></translation>
+        <translation>DBOX2 Isännän IP</translation>
     </message>
     <message>
         <source>DBOX2 Host IP is the remote device.</source>
@@ -7090,27 +7090,27 @@
     </message>
     <message>
         <source>Changing existing card inputs, deleting anything, or scanning for channels may not work.</source>
-        <translation type="unfinished"></translation>
+        <translation>Olemassaolevien asetusten, kuten sisääntulojen ja kanavaviritysten, muuttaminen ei ole suositeltavaa.</translation>
     </message>
     <message>
         <source>Channel Scanner</source>
-        <translation type="unfinished"></translation>
+        <translation>Kanavaselain</translation>
     </message>
     <message>
         <source>Starts the channel scanner.</source>
-        <translation type="unfinished"></translation>
+        <translation>Aloittaa kanavien virittämisen.</translation>
     </message>
     <message>
         <source>Transport Editor</source>
-        <translation type="unfinished"></translation>
+        <translation>Lähetysvirtojen Muokkaus</translation>
     </message>
     <message>
         <source>Allows you to edit the transports directly</source>
-        <translation type="unfinished"></translation>
+        <translation>Voidaan muokata lähetysvirtoja käsin</translation>
     </message>
     <message>
         <source>This is rarely required unless you are using a satelite dish and must enter an initial frequency to for the channel scanner to try.</source>
-        <translation type="unfinished"></translation>
+        <translation>Ei tarvita yleensä kuin satelliittikanavien virittämiseen.</translation>
     </message>
     <message>
         <source>(5_1) Underscore</source>
@@ -7134,7 +7134,7 @@
     </message>
     <message>
         <source>Using hardware MPEG decoder</source>
-        <translation type="unfinished"></translation>
+        <translation>Käyttää laitteiston MPEG purkua</translation>
     </message>
     <message>
         <source>This reduces the complexity of the stream that MythTV records so that it can be fed directly to a hardware MPEG decoder.</source>
@@ -7142,67 +7142,67 @@
     </message>
     <message>
         <source>Specifically, MythTV will record only one audio and one subtitle stream.</source>
-        <translation type="unfinished"></translation>
+        <translation>MythTV nauhoittaa vain yhden ääniraidan ja yhden tekstityskielen.</translation>
     </message>
     <message>
         <source>You will want to also set preferred languages in the frontend&apos;s Utilities/Setup:Setup:TV Settings:General(page 3).</source>
-        <translation type="unfinished"></translation>
+        <translation>Haluttu kieli  Mythfrontend:in asetuksista (Asetukset/TV:n Asetukset/Yleiset).</translation>
     </message>
     <message>
         <source>(Delete all capture cards)</source>
-        <translation type="unfinished"></translation>
+        <translation>(Poista TV-korttien asetukset)</translation>
     </message>
     <message>
         <source>Monitor Aspect Ratio</source>
-        <translation type="unfinished"></translation>
+        <translation>Kuvasuhde</translation>
     </message>
     <message>
         <source>4:3</source>
-        <translation type="unfinished">4:3</translation>
+        <translation>4:3</translation>
     </message>
     <message>
         <source>16:9</source>
-        <translation type="unfinished">16:9</translation>
+        <translation>16:9</translation>
     </message>
     <message>
         <source>16:10</source>
-        <translation type="unfinished">16:10</translation>
+        <translation>16:10</translation>
     </message>
     <message>
         <source>Continue</source>
-        <translation type="unfinished"></translation>
+        <translation>Jatka</translation>
     </message>
     <message>
         <source>Exit</source>
-        <translation type="unfinished"></translation>
+        <translation>Poistu</translation>
     </message>
     <message>
         <source>(Delete all video sources)</source>
-        <translation type="unfinished"></translation>
+        <translation>(Poista kaikki sisääntuloasetukset)</translation>
     </message>
     <message>
         <source>Display volume level information on LCD display.</source>
-        <translation type="unfinished"></translation>
+        <translation>Näytä äänenvoimakkuustietoja LCD:ssä.</translation>
     </message>
     <message>
         <source>The aspect ratio of a Xinerama display can not be queried from the display, so you must specify it.</source>
-        <translation type="unfinished"></translation>
+        <translation>Xineraman kuvasuhdetta ei voitu tiedustella näytöltä, joten se on määriteltävä itse.</translation>
     </message>
     <message>
         <source>Minimal Updates</source>
-        <translation type="unfinished"></translation>
+        <translation>Pienimmät Päivitykset</translation>
     </message>
     <message>
         <source>Rename to Match</source>
-        <translation type="unfinished"></translation>
+        <translation>Uudelleennimeä</translation>
     </message>
     <message>
         <source>Delete</source>
-        <translation type="unfinished">Poista</translation>
+        <translation>Poista</translation>
     </message>
     <message>
         <source>Existing Channel Treatment</source>
-        <translation type="unfinished"></translation>
+        <translation>Olemassaolevien Kanavien Kohtelu</translation>
     </message>
     <message>
         <source>How to treat existing channels.</source>
@@ -7210,35 +7210,35 @@
     </message>
     <message>
         <source>Analog V4L capture card</source>
-        <translation type="unfinished"></translation>
+        <translation>V4L-kortti</translation>
     </message>
     <message>
         <source>MPEG-2 encoder card (PVR-x50, PVR-500)</source>
-        <translation type="unfinished"></translation>
+        <translation>MPEG-2-kortti  (PVR-x50, PVR-500)</translation>
     </message>
     <message>
         <source>DVB DTV capture card (v3.x)</source>
-        <translation type="unfinished"></translation>
+        <translation>DVB DTV-kortti  (v3.x)</translation>
     </message>
     <message>
         <source>pcHDTV DTV capture card (w/V4L drivers)</source>
-        <translation type="unfinished"></translation>
+        <translation>pcHDTV DTV-kortti  (w/V4L drivers)</translation>
     </message>
     <message>
         <source>FireWire cable box</source>
-        <translation type="unfinished"></translation>
+        <translation>FireWire-kaapeliboksi</translation>
     </message>
     <message>
         <source>USB MPEG-4 encoder box (Plextor ConvertX, etc)</source>
-        <translation type="unfinished"></translation>
+        <translation>USB MPEG-4-boksi (Plextor ConvertX, etc)</translation>
     </message>
     <message>
         <source>DBox2 TCP/IP cable box</source>
-        <translation type="unfinished"></translation>
+        <translation>DBox2 TCP/IP-kaapeliboksi</translation>
     </message>
     <message>
         <source>Select the LNB Settings for DVB-S cards.</source>
-        <translation type="unfinished"></translation>
+        <translation>Valitse LNB Asetukset DVB-S korteille.</translation>
     </message>
     <message>
         <source>For DVB-C and DVB-T you don&apos;t need to set these values.</source>
@@ -7246,7 +7246,7 @@
     </message>
     <message>
         <source>Starting LiveTV channel.</source>
-        <translation type="unfinished"></translation>
+        <translation>Aloitetaan LiveTV.</translation>
     </message>
     <message>
         <source>This is updated on every successful channel change.</source>
@@ -7254,7 +7254,7 @@
     </message>
     <message>
         <source>Number of threads</source>
-        <translation type="unfinished"></translation>
+        <translation>Säikeiden lukumäärä</translation>
     </message>
     <message>
         <source>Threads to use for software encoding.</source>
@@ -7266,23 +7266,23 @@
     </message>
     <message>
         <source>MPEG-2 Parameters</source>
-        <translation type="unfinished">MPEG2:n Asetukset</translation>
+        <translation>MPEG-2:n Asetukset</translation>
     </message>
     <message>
         <source>Preferred MPEG2 Decoder</source>
-        <translation type="unfinished"></translation>
+        <translation>Haluttu MPEG2-Purkaja</translation>
     </message>
     <message>
         <source>libmpeg2</source>
-        <translation type="unfinished"></translation>
+        <translation>libmpeg2</translation>
     </message>
     <message>
         <source>Standard XvMC</source>
-        <translation type="unfinished"></translation>
+        <translation>Standardi XvMC</translation>
     </message>
     <message>
         <source>VIA XvMC</source>
-        <translation type="unfinished"></translation>
+        <translation>VIA XvMC</translation>
     </message>
     <message>
         <source>Decoder to use to play back MPEG2 video.</source>
@@ -7306,11 +7306,11 @@
     </message>
     <message>
         <source>Cable HRC</source>
-        <translation type="unfinished"></translation>
+        <translation>Kaapeli HRC</translation>
     </message>
     <message>
         <source>Frequency Table</source>
-        <translation type="unfinished"></translation>
+        <translation>Taajuusalue</translation>
     </message>
     <message>
         <source>Frequency table to use.</source>
@@ -7322,7 +7322,7 @@
     </message>
     <message>
         <source>ATSC Modulation</source>
-        <translation type="unfinished"></translation>
+        <translation>ATSC-Modulaatio</translation>
     </message>
     <message>
         <source>ATSC modulation, 8-VSB, QAM-256, etc.</source>
@@ -7334,15 +7334,15 @@
     </message>
     <message>
         <source>Could not query inputs.</source>
-        <translation type="unfinished"></translation>
+        <translation>Sisääntuloja ei voitu tiedustella.</translation>
     </message>
     <message>
         <source>ERROR, Compile with V4L support to query inputs</source>
-        <translation type="unfinished"></translation>
+        <translation>VIRHE, Käännä uudestaan käyttäen V4L-tukea</translation>
     </message>
     <message>
         <source>Subtype</source>
-        <translation type="unfinished"></translation>
+        <translation>Alatyyppi</translation>
     </message>
     <message>
         <source>Frontend ID</source>
@@ -7350,35 +7350,35 @@
     </message>
     <message>
         <source>Cable box model</source>
-        <translation type="unfinished"></translation>
+        <translation>Kaapeliboksin tyyppi</translation>
     </message>
     <message>
         <source>Connection Type</source>
-        <translation type="unfinished"></translation>
+        <translation>Yhteyden Tyyppi</translation>
     </message>
     <message>
         <source>IEEE-1394 Port</source>
-        <translation type="unfinished"></translation>
+        <translation>IEEE-1394-Portti</translation>
     </message>
     <message>
         <source>Node</source>
-        <translation type="unfinished"></translation>
+        <translation>Solmu</translation>
     </message>
     <message>
         <source>Speed</source>
-        <translation type="unfinished"></translation>
+        <translation>Nopeus</translation>
     </message>
     <message>
         <source>Could not open &apos;%1&apos; to probe its inputs.</source>
-        <translation type="unfinished"></translation>
+        <translation>Ei saatu avattua &apos;%1&apos;:sta sisääntulojen koettamiseksi.</translation>
     </message>
     <message>
         <source>ERROR, Compile with DVB support to query inputs</source>
-        <translation type="unfinished"></translation>
+        <translation>VIRHE, Käännä uudestaan käyttäen DVB-tukea</translation>
     </message>
     <message>
         <source>Deinterlace algorithm.</source>
-        <translation type="unfinished"></translation>
+        <translation>Lomituksen poistoalgoritmi.</translation>
     </message>
     <message>
         <source>&apos;Kernel&apos; requires SSE CPU support.</source>
@@ -7390,7 +7390,7 @@
     </message>
     <message>
         <source>General OSD time-out (sec)</source>
-        <translation type="unfinished"></translation>
+        <translation>Yleinen OSD:n näkyvyysaika (sekuntia)</translation>
     </message>
     <message>
         <source>How many seconds an on-screen display will be active after it is first activated.</source>
@@ -7398,7 +7398,7 @@
     </message>
     <message>
         <source>Program Info OSD time-out</source>
-        <translation type="unfinished"></translation>
+        <translation>Ohjelmatietojen OSD:n näkyvyysaika (sekuntia)</translation>
     </message>
     <message>
         <source>How many seconds the on-screen display will display the program information after it is first displayed.</source>
@@ -7406,7 +7406,7 @@
     </message>
     <message>
         <source>Use line edit virtual keyboards</source>
-        <translation type="unfinished"></translation>
+        <translation>Käytä virtuaalista näppäimistöä</translation>
     </message>
     <message>
         <source>Allows you to use a virtual keyboard in Myth line edit boxes.  To use, hit OK/Select while a line edit is in focus.</source>
@@ -8147,15 +8147,15 @@
     </message>
     <message>
         <source>Signal %1%</source>
-        <translation type="unfinished"></translation>
+        <translation>Signaali %1%</translation>
     </message>
     <message>
         <source>S/N %1 dB</source>
-        <translation type="unfinished"></translation>
+        <translation>Signaali/kohina %1 dB</translation>
     </message>
     <message>
         <source>Bit Errors %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Bitti-virheitä %1</translation>
     </message>
 </context>
 <context>
@@ -8341,11 +8341,11 @@
     </message>
     <message>
         <source>Are you sure you want to delete ALL video sources?</source>
-        <translation type="unfinished"></translation>
+        <translation>Poistetaanko varmasti kaikki kuvanlähteet?</translation>
     </message>
     <message>
         <source>Yes, delete video sources</source>
-        <translation type="unfinished"></translation>
+        <translation>Kyllä, poista kuvanlähteet</translation>
     </message>
 </context>
 <context>